## pypy3 7.3.1+dfsg

=== requirements.txt ===
--only-binary vmprof

cffi>=1.4.0

# parse log files in rvmprof tests
vmprof>=0.4.10; 'x86' in platform.machine #skip arm, s390x

# hypothesis is used for test generation on untranslated tests
hypothesis<4.40
enum34>=1.1.2

## pypy3 7.0.0+dfsg

=== debian/changelog ===
pypy3 (7.0.0+dfsg-3) unstable; urgency=medium

  * Let pypy3 attempt to build on hurd. It has been previously ported.
  * Fix webbrowser module. We had a patch that wasn't well ported to pypy3.
  * Patch hurd-sysmacros: Include <sys/sysmacros.h> on GNU/Hurd.
  * Remove old copyright file blocks for lib-python/2.7, it's no longer
    included, upstream.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 20 Feb 2019 17:31:35 -0800

pypy3 (7.0.0+dfsg-2) unstable; urgency=medium

  * Remove dh_builddeb override, no longer necessary.
  * Bump Standards-Version to 4.3.0, no changes needed.
  * Don't use dh_python3, it wasn't doing anything, anyway.
  * Patches from upstream release branch:
    - Set the version to 7.0.0, accidentally updated in a merge.
    - hypothesis-crashes: Handle older hypothesis versions better.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 08 Feb 2019 19:08:43 +0200

pypy3 (7.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Drop patches avoid-rvmprof-dummy, hurd, and rvmprof-dummy. Superseded
    upstream.
  * Update copyright.
  * Clean up after the new "extra_tests" directory.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 07 Feb 2019 15:34:05 +0200

pypy3 (6.0.0+dfsg-3) unstable; urgency=medium

  * Build-Depend on liblzma-dev, to build the lzma cffi module.
    Thanks Helmut Grohne. (Closes: #921494)
  * Bump Standards-Version to 4.3.0, no changes needed.
  * Ignore lib_pypy/_testmultiphase.c in clean.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 06 Feb 2019 17:10:24 +0200

pypy3 (6.0.0+dfsg-2) unstable; urgency=medium

   * Upload to unstable.
   * Patch graphlib-dots: Print some more mandlebrot while breaking cycles, to
     avoid build timeouts.
   * Add some superficial autopkgtests.
   * Support pip 10 in ensurepip.
   * pypy3-lib-testsuite: Don't attempt to byte-compile lib2to3's test data.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 31 Jan 2019 18:16:35 +0100

pypy3 (6.0.0+dfsg-1) experimental; urgency=medium

  * Initial release (based on pypy 6.0.0+dfsg-2 packaging). (Closes: #762346)

 -- Stefano Rivera <stefanor@debian.org>  Tue, 01 Jan 2019 20:02:42 +0000

=== debian/control ===
Source: pypy3
Section: python
Priority: optional
Maintainer: Stefano Rivera <stefanor@debian.org>
Build-Depends:
 debhelper (>= 9.20141010~),
 dh-exec,
 dpkg-dev (>= 1.17.14~),
 libbz2-dev,
 libexpat1-dev,
 libffi-dev,
 libgdbm-dev,
 liblzma-dev,
 libncurses-dev,
 libsqlite3-dev,
 libssl-dev | libssl1.0-dev,
 netbase,
 pkg-config,
 procps,
 pypy [any-amd64 any-i386 armhf ppc64 ppc64el s390x],
 python (>= 2.6.6-11~),
 python-docutils,
 python-pycparser,
 python-sphinx (>= 1.0.7+dfsg),
 python3-dev,
 tcl-dev,
 tk-dev,
 valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x],
 zlib1g-dev
Build-Depends-Indep: graphviz
Standards-Version: 4.3.0
Homepage: http://pypy.org/
Vcs-Git: https://salsa.debian.org/debian/pypy3.git
Vcs-Browser: https://salsa.debian.org/debian/pypy3
Rules-Requires-Root: no

Package: pypy3
Architecture: any
Depends: pypy3-lib (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: pypy3-dev (<< ${source:Version})
Provides: ${pypy3-abi}
Suggests: pypy3-doc, pypy3-tk (= ${binary:Version})
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: fast alternative implementation of Python 3.x - PyPy interpreter
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x). It has several advantages and distinct features:
  * Speed: thanks to its Just-in-Time compiler (on x86), Python programs often
    run faster on PyPy.
  * Memory usage: large, memory-hungry Python programs might end up taking less
    space than they do in CPython.
  * Compatibility: PyPy is highly compatible with existing Python code.
    It supports ctypes and can run popular Python libraries like twisted and
    django.
  * Stackless: PyPy supports stackless mode on most platforms, providing
    micro-threads for massive concurrency.
 .
 This package contains the PyPy interpreter for Python 3.x.

Package: pypy3-tk
Architecture: any
Depends: pypy3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: Tkinter module for PyPy (an alternative Python 3.x interpreter)
 A module for writing portable GUI applications with PyPy using Tk.
 Also known as Tkinter.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

Package: pypy3-lib
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Provides: ${cffi:Provides}
Description: standard library for PyPy (an alternative Python 3.x interpreter)
 The PyPy standard library. This is a combination of modules, copied directly
 from cpython, modified cpython modules, and modules entirely re-implemented
 (usually in pure Python, where they are C extensions in cpython).
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

Package: pypy3-lib-testsuite
Architecture: all
Depends: pypy3, pypy3-lib (>= ${source:Version}), ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Description: standard library test suite for PyPy (an alternative Python 3,x interpreter)
 The complete test suite for the PyPy standard library.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

Package: pypy3-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Suggests: python3-doc
Description: developer Documentation for PyPy (an alternative Python 3.x interpreter)
 The Developer documentation for PyPy. This mostly covers the internals of
 PyPy, and development of PyPy itself.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

Package: pypy3-dev
Architecture: all
Depends: pypy3 (>= ${source:Version}), ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Provides: libpypy-dev
Description: header files for PyPy (an alternative Python 3.x interpreter)
 Header files for compiling cpython C extension modules for use with PyPy.
 Note that pure Python modules will probably perform better.
 .
 PyPy supports a subset of cpython's C API through its CPyExt subsystem.
 .
 Also included is PyPy.h, for embedding the PyPy interpreter.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

=== debian/rules ===
#!/usr/bin/make -f

# Take advantage of PyPy if it's installed
PYTHON=$(shell command -v pypy > /dev/null && echo pypy || echo python2.7)

# PyPy doesn't harden well, and handles opt and debug itself
BUILDFLAGS_ENV := DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector,-fortify
BUILDFLAGS_ENV += DEB_CFLAGS_MAINT_STRIP="-O0 -O1 -O2 -O3 -Os -Ofast -g"
export CFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get CFLAGS)
export LDFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)

export PYPY_USESSION_BASENAME := debian

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  SUB_MAKEFLAGS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

%:
	dh $@ --with sphinxdoc

override_dh_auto_configure:
	# This rule left intentionally empty

override_dh_auto_build-arch: pypy/goal/pypy3-c
	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs

	# Build cffi modules
	debian/scripts/build-cffi-modules.py
	debian/scripts/multiarch-extensions.sh

override_dh_auto_build-indep:
	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs

pypy/goal/pypy3-c: export TMPDIR = $(CURDIR)/build-tmp
pypy/goal/pypy3-c: C_SRC_DIR = $(TMPDIR)/usession-$(PYPY_USESSION_BASENAME)-0/testing_1
pypy/goal/pypy3-c:
	rm -rf $(TMPDIR)
	mkdir $(TMPDIR)
	debian/scripts/translate.sh --python $(PYTHON)
	# PyPy captures all make output, so we call it ourselves, to avoid timeouts:
	$(MAKE) -C $(C_SRC_DIR) $(SUB_MAKEFLAGS)
	cp $(C_SRC_DIR)/pypy3-c $(C_SRC_DIR)/libpypy3-c.so $(dir $@)

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test-arch: export TMPDIR = $(CURDIR)/build-tests-tmp
override_dh_auto_test-arch: export HOME = $(TMPDIR)
override_dh_auto_test-arch:
	rm -rf $(TMPDIR) build-tests
	mkdir $(TMPDIR) build-tests
	# Test failures currently ignored
	PYTHONPATH=. $(PYTHON) -u testrunner/runner.py \
	                       --logfile=build-tests/pytest-A.log \
	                       --config=pypy/pytest-A.cfg \
	                       --root=pypy || true
	TERM=$${TERM:-dumb} $(PYTHON) -u pypy/test_all.py \
	          --pypy=pypy/goal/pypy3-c \
	          --resultlog=build-tests/lib-python.log \
	          lib-python || true
	pypy/goal/pypy3-c -u pypy/test_all.py \
	       --resultlog=build-tests/pypy-c.log \
	       pypy/module/pypyjit/test_pypy_c || true
endif

override_dh_auto_install:
	debian/scripts/gen-backend-versions.py

override_dh_fixperms-arch:
	debian/scripts/cleanup-lib.sh pypy3-lib
	find debian/pypy3-tk \( -name '*.pyc' -o -name '__pycache__' \) -delete
	# Fix interpreters
	find debian/pypy3-tk \
	     -name '*.py' -print0 \
	     | xargs -0 sed -i -e '1s|^#!.*python.*|#!/usr/bin/pypy3|'
	dh_fixperms -a

override_dh_fixperms-indep:
	debian/scripts/cleanup-lib.sh pypy3-lib-testsuite
	dh_fixperms -i

override_dh_sphinxdoc-arch:
	# dh_sphinxdoc doesn't fail silently when there are no docs

override_dh_compress:
	dh_compress -X.inv -X.txt

override_dh_installdeb:
	set -e; for maintscript in preinst postinst prerm; do \
		sed -e 's/#VERSION#/$(VER)/g' \
		    -e 's/#ARCH#/$(shell dpkg-architecture -qDEB_HOST_ARCH)/g' \
		    debian/pypy3.$$maintscript.in > debian/pypy3.$$maintscript; \
	done
	dh_installdeb

HG_REPO ?= https://bitbucket.org/pypy/pypy
REV=$(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p')
get-packaged-orig-source:
	@echo "You can build this from a local repo by supplying the HG_REPO variable"
	rm -rf pypy3-$(VER).orig
	hg clone $(HG_REPO) pypy3-$(VER).orig
ifeq (,$(REV))
	cd pypy3-$(VER).orig && hg up -r release-pypy3.5-v$(VER)
else
	cd pypy3-$(VER).orig && hg up -r $(REV)
endif
	rm -rf pypy3-$(VER).orig/.hg*
	rm pypy3-$(VER).orig/lib-python/*/distutils/command/*.exe
	rm -rf pypy3-$(VER).orig/lib-python/*/ensurepip/_bundled/
	tar -cJ --owner root --group root --mode a+rX \
	    -f pypy3_$(VER)+dfsg.orig.tar.xz pypy3-$(VER).orig
	rm -rf pypy3-$(VER).orig

=== debian/watch ===
version=3

# To repack, run debian/rules get-packaged-orig-source
opts=dversionmangle=s/\+dfsg// \
	https://bitbucket.org/pypy/pypy/downloads/ \
	pypy3-v([0-9.]+)-src\.tar\.bz2

## pypy3 7.1.1+dfsg

=== debian/changelog ===
pypy3 (7.1.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Strip blake2b.o from the orig tarball.
  * Switch to the 3.6 branch, the 3.5 branch is no longer being maintained
    upstream. (Closes: #993092)
  * Update watch file regex, upstream calls it pypy3.6 now.
  * Drop patches, superseded upstream: graphlib-dots, hypothesis-crashes,
    hurd-sysmacros.
  * Replace patch version-7.0.0 with version-7.1.1.
  * Refresh patches.
  * Update copyright.
  * Name pypy3{clean,compile} correctly in their own errors.
  * Drop multiarch-extensions.sh, not needed for pypy3.
  * Install _blake2 and _sha3 cffi modules.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 09 Aug 2019 12:50:05 -0300

=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,6 @@
 
 	# Build cffi modules
 	debian/scripts/build-cffi-modules.py
-	debian/scripts/multiarch-extensions.sh
 
 override_dh_auto_build-indep:
 	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs
@@ -99,12 +98,13 @@
 	rm -rf pypy3-$(VER).orig
 	hg clone $(HG_REPO) pypy3-$(VER).orig
 ifeq (,$(REV))
-	cd pypy3-$(VER).orig && hg up -r release-pypy3.5-v$(VER)
+	cd pypy3-$(VER).orig && hg up -r release-pypy3.6-v$(VER)
 else
 	cd pypy3-$(VER).orig && hg up -r $(REV)
 endif
 	rm -rf pypy3-$(VER).orig/.hg*
 	rm pypy3-$(VER).orig/lib-python/*/distutils/command/*.exe
+	rm pypy3-$(VER).orig/lib_pypy/_blake2/impl/blake2b.o
 	rm -rf pypy3-$(VER).orig/lib-python/*/ensurepip/_bundled/
 	tar -cJ --owner root --group root --mode a+rX \
 	    -f pypy3_$(VER)+dfsg.orig.tar.xz pypy3-$(VER).orig

## pypy3 7.3.1%2Bdfsg

=== debian/changelog ===
pypy3 (7.3.1+dfsg-4ubuntu0.1) focal-security; urgency=high

  * SECURITY UPDATE: Fix buffer overflow in SHA3 (Keccak) implementation.
  * References: CVE-2022-37454 (LP: #1995197).

 -- Stefano Rivera <stefanor@ubuntu.com>  Sat, 29 Oct 2022 18:45:41 +0200

pypy3 (7.3.1+dfsg-4) unstable; urgency=medium

  * Revert change to pypy3clean in 7.3.1+dfsg-2, that broke package removal.
    Build knowledge of cPython compatibility into pypy3clean, to determine pyc
    filenames.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 21 Apr 2020 21:49:20 -0700

pypy3 (7.3.1+dfsg-3) unstable; urgency=medium

  * Fix sqlite3 cffi build on armhf, there was an error in the ctypes-arm
    patch.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 21 Apr 2020 09:21:37 -0700

pypy3 (7.3.1+dfsg-2) unstable; urgency=medium

  * Cherry-pick a sqlite3 regression patch.
  * Point to the installed stdlib in the pypy-local sysconfig layout.
  * Build out autopkgtests a little. Test: cffi lib importability, local
    package installation, virtualenvs, byte-compilation.
  * Add /usr/local/lib/pypy3.6/dist-packages to sys.path, so users can locally
    install packages. (Closes: #956412)

 -- Stefano Rivera <stefanor@debian.org>  Mon, 20 Apr 2020 15:36:17 -0700

pypy3 (7.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release, upload to unstable
  * Refresh patches.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 10 Apr 2020 12:34:21 -0700

pypy3 (7.3.1~rc2+dfsg-1) experimental; urgency=medium

  * New upstream RC, upload to experimental
  * Update copyright.
  * Bump Standards-Version to 4.5.0, no changes needed.
  * Refresh patches.
  * Update build-cffi-modules to use upstream's new library location.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 09 Apr 2020 16:05:54 -0700

pypy3 (7.3.0+dfsg-4) unstable; urgency=medium

  * Patch: Build Sphinx docs with Python 3. This requires disabling autodoc
    and other custom extensions.
  * Byte compile exception patterns (bcep) changes following python3-defaults
    (3.8.2-2):
    - new "file" type to list just one file
      example: file|-4.0|/usr/share/foo/test.py
    - ignore lines that start with hash char. (to allow comments)
    - tighten checking directory name (partial match was possible before)
    - in "re" type's pattern - check relative paths in addition to full path
      (i.e. no need to include directory path in the pattern)
      example: re|-4.0|/usr/lib/bar|baz/test.*\.py
    - only warn about invalid patterns (instead of failing)
  * Execute python2 (instead of python) during the build.
  * We don't need python-docutils, any more.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 24 Mar 2020 19:16:53 -0700

pypy3 (7.3.0+dfsg-3) unstable; urgency=medium

  * Patch: Force s390x port to target z10 by default, fixing FTBFS.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 15 Jan 2020 09:53:22 +0000

pypy3 (7.3.0+dfsg-2) unstable; urgency=medium

  * Build-Depend on python2 instead of python.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 14 Jan 2020 07:57:50 +0200

pypy3 (7.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Drop patch arm64-gcc-bug, superseded upstream.
  * Update copyright.
  * Build with pypy on arm64, now that we've bootstrapped the JIT.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 24 Dec 2019 08:58:34 +0200

pypy3 (7.2.0+dfsg-1) unstable; urgency=medium

  * New upstream final release.
  * Upload to unstable.
  * Enable JIT and continuation module on arm64.
  * Refresh patches.
  * Patch arm64-gcc-bug: Avoid a GCC bug in the new arm64 JIT.
  * Bump Standards-Version to 4.4.1, no changes needed.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 02 Nov 2019 11:56:38 -0700

pypy3 (7.2.0~rc1+dfsg-1) experimental; urgency=medium

  * New upstream RC, uploaded to experimental.
  * Revert: Strip blake2b.o from the orig tarball.
  * Refresh patches.
  * Drop patch plat-linux-differences, superseded in cPython 3.6.
  * Update copyright.
  * Bump Standards-Version to 4.4.0, no changes needed.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 03 Oct 2019 14:49:58 +0300

=== debian/watch ===
version=3

# To repack, run debian/rules get-packaged-orig-source
opts=dversionmangle=s/\+dfsg// \
	https://bitbucket.org/pypy/pypy/downloads/ \
	pypy3.6-v([0-9.]+)-src\.tar\.bz2

## pypy3 7.3.1+dfsg

=== debian/changelog ===
pypy3 (7.3.1+dfsg-4ubuntu1) groovy; urgency=medium

  * Disable module-install-local|user tests, as they fail with new
    setuptools.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 17 Sep 2020 16:22:36 +0100

pypy3 (7.3.1+dfsg-4build2) groovy; urgency=medium

  * No change rebuild against new libffi8ubuntu1 ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 25 Aug 2020 12:14:03 +0100

pypy3 (7.3.1+dfsg-4build1) groovy; urgency=medium

  * No change rebuild against new libffi ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 20 Aug 2020 13:43:09 +0100

=== debian/tests/control ===
Tests: byte-compilation
Depends: pypy3, shunit2

Tests: command-line
Depends: pypy3, shunit2
Restrictions: superficial

Tests: pypy3-tk
Depends: pypy3-tk, shunit2
Restrictions: superficial

## Disable module-install-local|user, as it fails with new setuptools
#Tests: module-install-local Depends: build-essential, pypy3-dev,
#python3-setuptools, shunit2 Restrictions: needs-root

#Tests: module-install-user
#Depends: build-essential, pypy3-dev, python3-setuptools, shunit2

Tests: module-install-venv
Depends: build-essential, pypy3-dev, python-pip-whl, shunit2

Tests: module-install-virtualenv
Depends: build-essential, pypy3-dev, shunit2, virtualenv

## pypy3 7.3.3+dfsg

=== requirements.txt ===
--- 
+++ 
@@ -8,3 +8,6 @@
 # hypothesis is used for test generation on untranslated tests
 hypothesis<4.40
 enum34>=1.1.2
+
+# this is used by pypy/module/_hpy_universal/_vendored/hpy/devel
+pathlib

=== debian/changelog ===
pypy3 (7.3.3+dfsg-3) unstable; urgency=medium

  * Patch: CVE-2021-23336: Only use '&' as a query string separator.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 25 Feb 2021 10:55:51 -0800

pypy3 (7.3.3+dfsg-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * Drop patch s390x-z10, not needed since 7.3.1 dropped the assert we were
    protecting ourselves from.
  * Update s390x model target: z196 on Debian, zEC12 on Ubuntu < focal, z13 on
    Ubuntu >= focal.
  * Patch: Fix _crypt module's imports.
  * Patch: Fix utf-8 decode with errors=ignore.
  * Patch: Fix type annotation scoping bug.
  * Patch: Fix segfault in fcntl.

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + pypy3-doc: Add Multi-Arch: foreign.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 19 Dec 2020 12:26:35 -0800

pypy3 (7.3.3+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 21 Nov 2020 10:46:01 -0800

pypy3 (7.3.3~rc1+dfsg-1) experimental; urgency=medium

  * New upstream RC release.
    - Upload to experimental.
  * Refresh patches.
  * Update copyright.
  * Drop patch ppc64-jit-regression, superseded upstream.
  * Drop patch xdg-gvfs-open. Superseded upstream in 2.3 :P
  * Drop patch test_termios. No longer needed.
  * Carry over bdist-wininst-notfound from Debian's python3.8 package.
  * Update Homepage.
  * Add UpstreamMetadata.
  * Point watch URL at downloads.python.org, bitbucket is no longer used.
  * Fix some warnings in our fibc test package.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 12 Nov 2020 16:28:10 -0800

pypy3 (7.3.2+dfsg-2) unstable; urgency=medium

  * Patch: Fix JIT breakage on ppc64.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 26 Sep 2020 15:27:37 -0700

pypy3 (7.3.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Drop patches pip-10 and sqlite3-isolation-regression, superseded upstream.
  * Patch: Disable sphinx-affiliates search, not yet available in Debian.
  * Add support for -V to pypy3compile. Given we support BCEP, it makes sense,
    and will reduce package install noise.
  * Update copyright.
  * Use upstream's tool to build cffi modules, directly. It is useable
    stand-alone, these days, and catches failures.
  * Reorganize patches and prefix their commit messages with a category.
  * Patch: Ignore InvalidTerminal exception in test_readline under TERM=dumb.
  * Patch: Handle InvalidTerminal in rlcompleter.
  * Patch: Ignore fcntl test lease failures known to occur on tmpfs on older
    kernels (e.g. current buildds).
  * Strip rpython/rlib/test/loadtest/loadtest*.dll from the source package.
  * Run pypyjit tests under python 2.
  * Tweak distutils-install-layout patch to avoid duplicate sys.path entries
    when not in the installed layout.
  * Fix ensurepip._uninstall, broken in our ensurepip-wheels patch.
  * Build-Depend on python-pip-whl, used by test_venv.
  * Disable zip_safe in our autopkgtest test packages with C extensions.
    setuptools 47.3.2 broke C extension imports from eggs.
  * Patch: Use the python2 binary to run the internal test suite. Debian
    doesn't have a python binary any more.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 25 Sep 2020 20:29:03 -0700

=== debian/control ===
--- 
+++ 
@@ -17,19 +17,19 @@
  netbase,
  pkg-config,
  procps,
- pypy [any-amd64 any-i386 armhf ppc64 ppc64el s390x],
- python (>= 2.6.6-11~),
- python-docutils,
+ pypy [any-amd64 any-i386 arm64 armhf ppc64 ppc64el s390x],
+ python-pip-whl,
  python-pycparser,
- python-sphinx (>= 1.0.7+dfsg),
+ python2,
  python3-dev,
+ python3-sphinx (>= 1.0.7+dfsg),
  tcl-dev,
  tk-dev,
  valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x],
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 4.3.0
-Homepage: http://pypy.org/
+Standards-Version: 4.5.0
+Homepage: https://www.pypy.org/
 Vcs-Git: https://salsa.debian.org/debian/pypy3.git
 Vcs-Browser: https://salsa.debian.org/debian/pypy3
 Rules-Requires-Root: no
@@ -97,6 +97,7 @@
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Suggests: python3-doc
+Multi-Arch: foreign
 Description: developer Documentation for PyPy (an alternative Python 3.x interpreter)
  The Developer documentation for PyPy. This mostly covers the internals of
  PyPy, and development of PyPy itself.

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
 
 	# Build cffi modules
-	debian/scripts/build-cffi-modules.py
+	pypy/goal/pypy3-c lib_pypy/pypy_tools/build_cffi_imports.py
 
 override_dh_auto_build-indep:
 	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs
@@ -55,9 +55,10 @@
 	          --pypy=pypy/goal/pypy3-c \
 	          --resultlog=build-tests/lib-python.log \
 	          lib-python || true
-	pypy/goal/pypy3-c -u pypy/test_all.py \
-	       --resultlog=build-tests/pypy-c.log \
-	       pypy/module/pypyjit/test_pypy_c || true
+	$(PYTHON) -u pypy/test_all.py \
+	          --pypy=pypy/goal/pypy3-c \
+	          --resultlog=build-tests/pypy-c.log \
+	          pypy/module/pypyjit/test_pypy_c || true
 endif
 
 override_dh_auto_install:
@@ -92,7 +93,7 @@
 
 HG_REPO ?= https://bitbucket.org/pypy/pypy
 REV=$(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
-VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p')
+VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p' | sed -e 's/~//')
 get-packaged-orig-source:
 	@echo "You can build this from a local repo by supplying the HG_REPO variable"
 	rm -rf pypy3-$(VER).orig
@@ -104,7 +105,7 @@
 endif
 	rm -rf pypy3-$(VER).orig/.hg*
 	rm pypy3-$(VER).orig/lib-python/*/distutils/command/*.exe
-	rm pypy3-$(VER).orig/lib_pypy/_blake2/impl/blake2b.o
+	rm pypy3-$(VER).orig/rpython/rlib/test/loadtest/loadtest*.dll
 	rm -rf pypy3-$(VER).orig/lib-python/*/ensurepip/_bundled/
 	tar -cJ --owner root --group root --mode a+rX \
 	    -f pypy3_$(VER)+dfsg.orig.tar.xz pypy3-$(VER).orig

=== debian/watch ===
version=3

# To repack, run debian/rules get-packaged-orig-source
opts=dversionmangle=s/\+dfsg// \
	https://downloads.python.org/pypy/pypy3.6-v([0-9.]+)-src.tar.bz2

## pypy3 7.3.5%2Bdfsg

=== debian/changelog ===
pypy3 (7.3.5+dfsg-2+deb11u5) bullseye-security; urgency=medium

  * Apply security patches for CVEs in the standard library:
     * CVE-2024-6232: TarFile header parsing was vulnerable to ReDoS
     * CVE-2024-6923: The email module didn’t properly quote newlines for
       email headers allowing injections.
     * CVE-2024-7592: HTTP cookie parser incorrectly processed backslashes
       resulting in excessive CPU usage.
     * CVE-2024-11168 and CVE-2025-0938: Process square brackets in URLs
       according to RFC 3986.
     * CVE-2025-1795: Separating comma could be Unicode-encoded
     * CVE-2025-6069: html.parser.HTMLParser class had worse-case quadratic
       complexity when processing certain crafted malformed inputs
     * CVE-2025-8291: zipfile module did not check consistency of the zip64
       end of central directory record.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 31 Oct 2025 08:04:59 +0100

pypy3 (7.3.5+dfsg-2+deb11u4) bullseye-security; urgency=medium

  * Security patches to the standard library:
    - Apply cPython upstream security fix for CVE-2022-45061:
      Fix quadratic time idna decoding.
    - Apply cPython upstream security fix for CVE-2022-0391:
      Remove the newline, and tab early from query and fragments.
    - Apply cPython upstream security fix for CVE-2021-3737:
      Fix http client infinite line reading (DoS) after
      a HTTP 100 Continue.
    - Apply cPython upstream security fix for CVE-2024-9287:
      Quote template strings in `venv` activation scripts.
    - Apply cPython upstream security fix for CVE-2021-28861:
      Fix an open redirection vulnerability in http.server.
    - Apply cPython upstream security fix for CVE-2023-27043:
      Reject malformed addresses in email.parseaddr().
  * Apply upstream security fix CVE-2020-10735:
    Prevent DoS by large int<->str conversions,
    implement the int_max_str_digits handling.
  * Apply security fix for CVE-2020-29651 in the bundled python-py:
    svnwc: fix regular expression vulnerable to DoS.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 26 Nov 2024 09:18:20 +0100

pypy3 (7.3.5+dfsg-2+deb11u3) bullseye-security; urgency=medium

  * Security patches to the standard library:
    - Apply cPython upstream security fix for CVE-2023-24329:
      Strip C0 control and space characters in urlsplit.
    - Apply cPython upstream security fix for CVE-2023-40217:
      Avoid bypass TLS of handshake protections on closed sockets.
    - Apply cPython upstream security fix for CVE-2023-6597:
      tempfile.TemporaryDirectory: fix symlink bug in cleanup.
    - Apply cPython upstream security fix for CVE-2024-0450:
      Protect zipfile from "quoted-overlap" zipbomb.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 06 Nov 2024 21:11:12 +0100

pypy3 (7.3.5+dfsg-2+deb11u2) bullseye-security; urgency=medium

  * Patch: Resolve CVE-2022-37454, a buffer overflow in SHA-3 (Keccak).

 -- Stefano Rivera <stefanor@debian.org>  Tue, 01 Nov 2022 21:40:38 +0200

pypy3 (7.3.5+dfsg-2+deb11u1) bullseye; urgency=medium

  * Patch: Remove extraneous #endif from import.h (Closes: #1001519)

 -- Stefano Rivera <stefanor@debian.org>  Sat, 25 Dec 2021 11:54:46 -0400

pypy3 (7.3.5+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 03 Jun 2021 15:59:21 -0400

pypy3 (7.3.5+dfsg-1) experimental; urgency=medium

  * New upstream point release.
  * Refresh patches.
  * Drop patches cve-2021-3426 and ftplib-restrict-pasv, superseded upstream.
  * Drop Pre-Depends dpkg (>= 1.15.6~). xz is always supported, these days.
  * Move more translation logic into debian/scripts/translate.sh
  * Use the bundled pycparser for translation, so that Debian can drop the
    python-pycparser binary package.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 23 May 2021 08:05:03 -0400

pypy3 (7.3.4+dfsg-2) experimental; urgency=medium

  * Move pypy3 dependencies to Pre-Depends, as the pypy3 binary is used in
    package maintainer scripts. (Closes: #987908)
  * Remove pydoc getfile feature. (CVE-2021-3426)
  * security: Restrict ftplib PASV hosts (no CVE assigned).

 -- Stefano Rivera <stefanor@debian.org>  Sun, 02 May 2021 12:32:41 -0400

pypy3 (7.3.4+dfsg-1) experimental; urgency=medium

  * New upstream release (identical to RC2).

 -- Stefano Rivera <stefanor@debian.org>  Mon, 12 Apr 2021 17:05:09 -0400

pypy3 (7.3.4~rc2+dfsg-1) experimental; urgency=medium

  * New upstream RC.
  * Refresh patches.
  * Drop patch no-sphinx-affiliates, superseded upstream.
  * Update copyright.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 05 Apr 2021 14:08:41 -0700

pypy3 (7.3.4~rc1+dfsg-1) experimental; urgency=medium

  * New upstream RC.
    - Upload to experimental.
    - Targeting Python 3.7 compatibility.
  * Refresh patches.
  * Drop patches, superseded upstream: core-type-annotation-scoping,
    core-utf8-errors-ignore, cve-2021-23336, fcntl-segfault, and
    fix-_crypt-imports.
  * Replace deprecated imp.get_tag() in the byte-compilation autopkgtest.
  * Update copyright.
  * Bump Standards-Version to 4.5.1, no changes needed.
  * Bump watch file version to 4.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 27 Mar 2021 08:32:38 -0700

## pypy3 7.3.5+dfsg

=== requirements.txt ===
--- 
+++ 
@@ -1,5 +1,6 @@
 --only-binary vmprof
-
+# because the win64 build worker get confused whether it is 32 or 64-bit
+--no-binary cffi
 cffi>=1.4.0
 
 # parse log files in rvmprof tests

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,6 @@
  procps,
  pypy [any-amd64 any-i386 arm64 armhf ppc64 ppc64el s390x],
  python-pip-whl,
- python-pycparser,
  python2,
  python3-dev,
  python3-sphinx (>= 1.0.7+dfsg),
@@ -28,7 +27,7 @@
  valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x],
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://www.pypy.org/
 Vcs-Git: https://salsa.debian.org/debian/pypy3.git
 Vcs-Browser: https://salsa.debian.org/debian/pypy3
@@ -36,11 +35,14 @@
 
 Package: pypy3
 Architecture: any
-Depends: pypy3-lib (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}
 Breaks: pypy3-dev (<< ${source:Version})
 Provides: ${pypy3-abi}
 Suggests: pypy3-doc, pypy3-tk (= ${binary:Version})
-Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
+Pre-Depends:
+ pypy3-lib (= ${binary:Version}),
+ ${misc:Pre-Depends},
+ ${shlibs:Pre-Depends}
 Description: fast alternative implementation of Python 3.x - PyPy interpreter
  PyPy is a fast, compliant alternative implementation of the Python language
  (3.x). It has several advantages and distinct features:
@@ -59,7 +61,6 @@
 Package: pypy3-tk
 Architecture: any
 Depends: pypy3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Description: Tkinter module for PyPy (an alternative Python 3.x interpreter)
  A module for writing portable GUI applications with PyPy using Tk.
  Also known as Tkinter.
@@ -71,7 +72,6 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}
-Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Provides: ${cffi:Provides}
 Description: standard library for PyPy (an alternative Python 3.x interpreter)
  The PyPy standard library. This is a combination of modules, copied directly
@@ -84,7 +84,6 @@
 Package: pypy3-lib-testsuite
 Architecture: all
 Depends: pypy3, pypy3-lib (>= ${source:Version}), ${misc:Depends}
-Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Description: standard library test suite for PyPy (an alternative Python 3,x interpreter)
  The complete test suite for the PyPy standard library.
  .
@@ -95,7 +94,6 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
-Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Suggests: python3-doc
 Multi-Arch: foreign
 Description: developer Documentation for PyPy (an alternative Python 3.x interpreter)
@@ -108,7 +106,6 @@
 Package: pypy3-dev
 Architecture: all
 Depends: pypy3 (>= ${source:Version}), ${misc:Depends}
-Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Provides: libpypy-dev
 Description: header files for PyPy (an alternative Python 3.x interpreter)
  Header files for compiling cpython C extension modules for use with PyPy.

=== debian/rules ===
--- 
+++ 
@@ -8,12 +8,6 @@
 BUILDFLAGS_ENV += DEB_CFLAGS_MAINT_STRIP="-O0 -O1 -O2 -O3 -Os -Ofast -g"
 export CFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get CFLAGS)
 export LDFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)
-
-export PYPY_USESSION_BASENAME := debian
-
-ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-  SUB_MAKEFLAGS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-endif
 
 %:
 	dh $@ --with sphinxdoc
@@ -30,15 +24,8 @@
 override_dh_auto_build-indep:
 	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs
 
-pypy/goal/pypy3-c: export TMPDIR = $(CURDIR)/build-tmp
-pypy/goal/pypy3-c: C_SRC_DIR = $(TMPDIR)/usession-$(PYPY_USESSION_BASENAME)-0/testing_1
 pypy/goal/pypy3-c:
-	rm -rf $(TMPDIR)
-	mkdir $(TMPDIR)
 	debian/scripts/translate.sh --python $(PYTHON)
-	# PyPy captures all make output, so we call it ourselves, to avoid timeouts:
-	$(MAKE) -C $(C_SRC_DIR) $(SUB_MAKEFLAGS)
-	cp $(C_SRC_DIR)/pypy3-c $(C_SRC_DIR)/libpypy3-c.so $(dir $@)
 
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test-arch: export TMPDIR = $(CURDIR)/build-tests-tmp
@@ -46,11 +33,13 @@
 override_dh_auto_test-arch:
 	rm -rf $(TMPDIR) build-tests
 	mkdir $(TMPDIR) build-tests
+	ln -sf lib_pypy/cffi/_pycparser/ pycparser
 	# Test failures currently ignored
 	PYTHONPATH=. $(PYTHON) -u testrunner/runner.py \
 	                       --logfile=build-tests/pytest-A.log \
 	                       --config=pypy/pytest-A.cfg \
 	                       --root=pypy || true
+	rm pycparser
 	TERM=$${TERM:-dumb} $(PYTHON) -u pypy/test_all.py \
 	          --pypy=pypy/goal/pypy3-c \
 	          --resultlog=build-tests/lib-python.log \
@@ -83,6 +72,10 @@
 override_dh_compress:
 	dh_compress -X.inv -X.txt
 
+override_dh_shlibdeps-arch:
+	dh_shlibdeps --package=pypy3 -- -dPre-Depends
+	dh_shlibdeps --arch --remaining-packages
+
 override_dh_installdeb:
 	set -e; for maintscript in preinst postinst prerm; do \
 		sed -e 's/#VERSION#/$(VER)/g' \
@@ -99,7 +92,7 @@
 	rm -rf pypy3-$(VER).orig
 	hg clone $(HG_REPO) pypy3-$(VER).orig
 ifeq (,$(REV))
-	cd pypy3-$(VER).orig && hg up -r release-pypy3.6-v$(VER)
+	cd pypy3-$(VER).orig && hg up -r release-pypy3.7-v$(VER)
 else
 	cd pypy3-$(VER).orig && hg up -r $(REV)
 endif

=== debian/tests/control ===
Tests: byte-compilation
Depends: pypy3, shunit2

Tests: command-line
Depends: pypy3, shunit2
Restrictions: superficial

Tests: pypy3-tk
Depends: pypy3-tk, shunit2
Restrictions: superficial

Tests: module-install-local
Depends: build-essential, pypy3-dev, python3-setuptools, shunit2
Restrictions: needs-root

Tests: module-install-user
Depends: build-essential, pypy3-dev, python3-setuptools, shunit2

Tests: module-install-venv
Depends: build-essential, pypy3-dev, python-pip-whl, shunit2

Tests: module-install-virtualenv
Depends: build-essential, pypy3-dev, shunit2, virtualenv

=== debian/watch ===
version=4

# To repack, run debian/rules get-packaged-orig-source
opts=dversionmangle=s/\+dfsg// \
	https://downloads.python.org/pypy/pypy3.7-v([0-9.]+)-src.tar.bz2

## pypy3 7.3.9+dfsg

=== extra_tests/requirements.txt ===
pytest<=4.0
setuptools<60.0
hypothesis
vmprof

=== debian/changelog ===
pypy3 (7.3.9+dfsg-1ubuntu0.1) jammy-security; urgency=high

  * SECURITY UPDATE: Fix buffer overflow in SHA3 (Keccak) implementation.
  * References: CVE-2022-37454 (LP: #1995197)

 -- Stefano Rivera <stefanor@ubuntu.com>  Sat, 29 Oct 2022 18:49:55 +0200

pypy3 (7.3.9+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Synchronise module-install-* autopkgtests with python3 3.10.2-7:
    - Test install destination.
    - Test setuptools develop installations.
    - Test installation via pip (in virtualenvs, we don't have a pypy-pip
      package).
  * Correct a typo in the deb_system sysconfig layout.
  * Patch: Fix editable installs with setuptools < 60.0.1.
  * Add missing /local/ to data path in sysconfig posix_local scheme.
  * Improve support for setuptools > 60's bundled distutils in
    _distutils_system_mod, supporting a wider range of versions and more
    reliably selecting the posix_local scheme.
  * Use the same is_virtual_environment() proposed in PEP 668 across the site,
    sysconfig, and distutils modules. Stop checking for PYTHONUSERBASE or
    VIRTUAL_ENV environment variables.
  * Change the "include" and "platinclude" paths in the "posix_local" scheme
    to refer to the location of Python's headers, not the install location for
    modules' C headers.
  * Avoid infinite recursion in _distutils_system_mod when
    SETUPTOOLS_USE_DISTUTILS=local.
  * Avoid crashing in `_distutils_system_mod` if we find an older version of
    distutils (from before `_distutils_system_mod` was implemented).

 -- Stefano Rivera <stefanor@debian.org>  Thu, 31 Mar 2022 21:37:48 -0400

pypy3 (7.3.8+dfsg-2) unstable; urgency=medium

  * Correct the license for osx-roots.diff.
  * Build-Depend on valgrind-if-available, instead of a hardcoded arch list.
  * Update distutils-install-layout to provide a _distutils_system_mod module,
    as used by modern setuptools.
  * Fix --system-site-packages venvs, they weren't functioning due to a logic
    bug in the distutils-install-layout patch.
  * Add an autopkgtest to check sys.path setup.
  * Exclude /usr/lib/pypy3.8/site-packages/ from pypy3-lib, it's not used.
  * Declare Breaks python3-virtualenv (<< 20.13.0+ds-2~), as older versions
    won't create isolated virtualenvs for pypy3.8.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 04 Mar 2022 21:31:54 -0400

pypy3 (7.3.8+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Upload to unstable.
  * Refresh patches.
  * Drop RC2 patch, superseded by final release.
  * Update copyright.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 20 Feb 2022 14:19:13 -0400

pypy3 (7.3.8~rc1+dfsg-2) experimental; urgency=medium

  * Patch: Update to RC2
  * Drop patches cffi-bundled-pycparser and doc-version, superseded upstream.
  * Update copyright.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 11 Feb 2022 10:14:40 -0400

pypy3 (7.3.8~rc1+dfsg-1) experimental; urgency=medium

  * New upstream RC.
    - Targeting Python 3.8 compatibility.
    - Upload to experimental.
  * Refresh patches.
  * The package layout is updated to use the posix_* schemes, now that this is
    supported upstream.
  * Drop patches multiarch-tag, openssl-3.0.0, and platform-lsbrelease:
    superseded upstream.
  * PyPy.h was dropped upstream, cffi should be used for embedding PyPy.
  * Patch cffi-bundled-pycparser: Fix a cffi regression.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 30 Jan 2022 17:55:33 -0400

pypy3 (7.3.7+dfsg-5) unstable; urgency=medium

  * Re-instate pypy3-lib.prerm, duplicating the pypy3clean from pypy3.prerm to
    clean up pypy3-lib .pyc files before upgrading it. (See: #1004369)
    - Add some one-off cleanup for 7.3.7+dfsg-4.
  * Exclude make_ssl_data.py from pypy3-lib, this a developer tool.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 27 Jan 2022 07:43:51 -0400

pypy3 (7.3.7+dfsg-4) unstable; urgency=medium

  * Patch: OpenSSL 3.0.0 support.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 18 Jan 2022 17:05:06 -0400

pypy3 (7.3.7+dfsg-3) unstable; urgency=medium

  * Handle multiple wheels for the same package in python-pip-whl.
  * Mark module-install-venv and module-install-virtualenv autopkgtests as
    allow-stderr, too. Virtualenvs now get a newer setuptools.
  * Migrate to individual wheel packages. Add a new binary package, pypy3-venv
    to depend on the wheel packages. (Closes: #1003573)

 -- Stefano Rivera <stefanor@debian.org>  Thu, 13 Jan 2022 19:05:35 -0400

pypy3 (7.3.7+dfsg-2) unstable; urgency=medium

  * Mark autopkgtests that call setup.py as allow-stderr. setuptools now emits
    a warning. (Closes: #1001721)

 -- Stefano Rivera <stefanor@debian.org>  Sat, 25 Dec 2021 11:45:03 -0400

pypy3 (7.3.7+dfsg-1) unstable; urgency=medium

  * New upstream release, reverting accidental ABI change in 7.3.6.
  * Refresh patches.
  * ensurepip-wheels patch: Don't crash on an assertion in version() while
    building the argparse parser if python-pip-whl isn't installed, rather
    return None. (Closes: #996822)
  * ensurepip-disabled patch: Refer to python3-pip not python-pip.
  * Patch doc-version: Set upstream version to 7.3.7, in the docs.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 25 Oct 2021 18:49:41 -0700

pypy3 (7.3.6+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.
  * Drop patches multiarch, multiarch-from-env superseded upstream.
  * Patch: Use the multiarch tuple in the import .so name, rather than
    incomplete heuristics. Fixes FTBFS on hppa.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 17 Oct 2021 11:33:01 -0700

pypy3 (7.3.6~rc2+dfsg-2) experimental; urgency=medium

  * Patch: determine the multiarch tuple from $DEB_HOST_MULTIARCH at build
    time, fixing FTBFS on non-JIT architectures.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 07 Oct 2021 17:41:06 -0700

pypy3 (7.3.6~rc2+dfsg-1) experimental; urgency=medium

  * New upstream RC.
  * Refresh patches.


=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: pypy3
 Section: python
 Priority: optional
-Maintainer: Stefano Rivera <stefanor@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Stefano Rivera <stefanor@debian.org>
 Build-Depends:
  debhelper (>= 9.20141010~),
  dh-exec,
@@ -18,16 +19,17 @@
  pkg-config,
  procps,
  pypy [any-amd64 any-i386 arm64 armhf ppc64 ppc64el s390x],
- python-pip-whl,
  python2,
  python3-dev,
+ python3-pip-whl,
+ python3-setuptools-whl,
  python3-sphinx (>= 1.0.7+dfsg),
  tcl-dev,
  tk-dev,
- valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x],
+ valgrind-if-available,
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://www.pypy.org/
 Vcs-Git: https://salsa.debian.org/debian/pypy3.git
 Vcs-Browser: https://salsa.debian.org/debian/pypy3
@@ -36,7 +38,7 @@
 Package: pypy3
 Architecture: any
 Depends: ${misc:Depends}
-Breaks: pypy3-dev (<< ${source:Version})
+Breaks: pypy3-dev (<< ${source:Version}), python3-virtualenv (<< 20.13.0+ds-2~)
 Provides: ${pypy3-abi}
 Suggests: pypy3-doc, pypy3-tk (= ${binary:Version})
 Pre-Depends:
@@ -113,7 +115,18 @@
  .
  PyPy supports a subset of cpython's C API through its CPyExt subsystem.
  .
- Also included is PyPy.h, for embedding the PyPy interpreter.
+ PyPy is a fast, compliant alternative implementation of the Python language
+ (3.x).
+
+Package: pypy3-venv
+Architecture: all
+Depends:
+ pypy3 (>= ${source:Version}),
+ python3-pip-whl,
+ python3-setuptools-whl,
+ ${misc:Depends}
+Description: fast alternative implementation of Python 3.x - PyPy venv module
+ This package will install the dependencies of the PyPy 3 venv module.
  .
  PyPy is a fast, compliant alternative implementation of the Python language
  (3.x).

=== debian/rules ===
--- 
+++ 
@@ -77,29 +77,29 @@
 	dh_shlibdeps --arch --remaining-packages
 
 override_dh_installdeb:
-	set -e; for maintscript in preinst postinst prerm; do \
-		sed -e 's/#VERSION#/$(VER)/g' \
-		    -e 's/#ARCH#/$(shell dpkg-architecture -qDEB_HOST_ARCH)/g' \
-		    debian/pypy3.$$maintscript.in > debian/pypy3.$$maintscript; \
-	done
+	debian/scripts/maintscript.sh pypy3.preinst
+	debian/scripts/maintscript.sh pypy3.postinst
+	debian/scripts/maintscript.sh pypy3.prerm
+	debian/scripts/maintscript.sh pypy3-lib.prerm
 	dh_installdeb
 
 HG_REPO ?= https://bitbucket.org/pypy/pypy
-REV=$(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
-VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p' | sed -e 's/~//')
+REV = $(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
+DVER = $(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p')
+UVER = $(shell echo $(DVER) | sed -e 's/~//')
 get-packaged-orig-source:
 	@echo "You can build this from a local repo by supplying the HG_REPO variable"
-	rm -rf pypy3-$(VER).orig
-	hg clone $(HG_REPO) pypy3-$(VER).orig
+	rm -rf pypy3-$(DVER).orig
+	hg clone $(HG_REPO) pypy3-$(DVER).orig
 ifeq (,$(REV))
-	cd pypy3-$(VER).orig && hg up -r release-pypy3.7-v$(VER)
+	cd pypy3-$(DVER).orig && hg up -r release-pypy3.8-v$(UVER)
 else
-	cd pypy3-$(VER).orig && hg up -r $(REV)
+	cd pypy3-$(DVER).orig && hg up -r $(REV)
 endif
-	rm -rf pypy3-$(VER).orig/.hg*
-	rm pypy3-$(VER).orig/lib-python/*/distutils/command/*.exe
-	rm pypy3-$(VER).orig/rpython/rlib/test/loadtest/loadtest*.dll
-	rm -rf pypy3-$(VER).orig/lib-python/*/ensurepip/_bundled/
+	rm -rf pypy3-$(DVER).orig/.hg*
+	rm pypy3-$(DVER).orig/lib-python/*/distutils/command/*.exe
+	rm pypy3-$(DVER).orig/rpython/rlib/test/loadtest/loadtest*.dll
+	rm -rf pypy3-$(DVER).orig/lib-python/*/ensurepip/_bundled/
 	tar -cJ --owner root --group root --mode a+rX \
-	    -f pypy3_$(VER)+dfsg.orig.tar.xz pypy3-$(VER).orig
-	rm -rf pypy3-$(VER).orig
+	    -f pypy3_$(DVER)+dfsg.orig.tar.xz pypy3-$(DVER).orig
+	rm -rf pypy3-$(DVER).orig

=== debian/watch ===
version=4

# To repack, run debian/rules get-packaged-orig-source
opts=dversionmangle=s/\+dfsg// \
	https://downloads.python.org/pypy/pypy3.8-v([0-9.]+)-src.tar.bz2
